#ifndef CSMS_H
#define CSMS_H

#include "IRdsText.h"
#include <QtDBus>

class CSms : public IRdsText
{
    Q_OBJECT;
public:
    CSms(QObject * parent);
    virtual ~CSms();

    static CSms& self(){return *m_self;}

    /// Displayed text format
    void    setFormat(QString value);
    QString getFormat();
    // End time
    void    setTimeout(int value);
    int getTimeout();
    // state plug on or off
    void    setEnable(bool value);
    bool getEnable();
    bool getState();
    // connect plug
    void setConnect(int value);

signals:
    /// emitted when ever the new text is changed
    void sigChanged(QString,int);

private:
    // Send text to writer
    void sendText(QString text);

    static CSms * m_self;

    /// the format of rds displayed data
    QString format;
    // Formated text
    QString smsText;
    // tiimeout of displayed text
    int timeout;
    // Pluig status
    bool state;
    // Tx connect state
    bool bConnect;

private slots:
    void slotNotify(QList<QVariant> var);
    void slotComingChanged(QDBusObjectPath objPath, QString channel,uint ukn,uint num,bool act);
    void slotTextReceived(uint ukn,uint time,uint chan, uint ukn2, uint ukn3,QString text);

};

#endif // CSMS_H
